import { buildUUID } from '../../../utils/uuid';
import { ApiActionPage } from '../../model/baseModel';
import {
  PackageRuleListItem,
  PackageRulePageParams,
  PackageRulePageListGetResultModel,
} from '../model/basModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';
import { useUserStore } from '../../../store/modules/user';

/*
 * 获取包装规则分页列表
 */
export const getPackageRuleListByPage = async (params: PackageRulePageParams) => {
  let sqlcmd = '';
  if (params?.SN != undefined && params?.SN != '') {
    sqlcmd += "And SN like '%" + params?.SN + "%'";
  }
  if (params?.PARENT_SN != undefined && params?.PARENT_SN != '') {
    sqlcmd += "And PARENT_SN like '%" + params?.PARENT_SN + "%'";
  }
  if (params?.ITEM_CODE != undefined && params?.ITEM_CODE != '') {
    sqlcmd += "And ITEM_CODE like '%" + params?.ITEM_CODE + "%'";
  }
  if (params?.TRANS_NO != undefined && params?.TRANS_NO != '') {
    sqlcmd += "And TRANS_NO like '%" + params?.TRANS_NO + "%'";
  }
  if (params?.WH_CODE != undefined && params?.WH_CODE != '') {
    sqlcmd += "And WH_CODE like '%" + params?.WH_CODE + "%'";
  }
  if (params?.REGION_CODE != undefined && params?.REGION_CODE != '') {
    sqlcmd += "And REGION_CODE like '%" + params?.REGION_CODE + "%'";
  }
  const rParams = genActionPage('WMS_ITEM_PKG', sqlcmd, params.page, params.pageSize);
  return getPackageRuleListByPageAsync(rParams);
};
async function getPackageRuleListByPageAsync(params: ApiActionPage) {
    const data = await defHttp.post<ApiActionPage>(
      { url: Api.EntityPageList, params },
      {
        isTransformResponse: false,
      },
    );
  const model: PackageRulePageListGetResultModel = {
    items: data.Data.data,
    total: data.Data.totals,
  };
  return model;
}
//保存
export const SavePackageRule = async (params: PackageRuleListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('WMS_ITEM_PKG', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    params.CREATE_USER = useUserStore().getUserInfo.userId;
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('WMS_ITEM_PKG', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};
//删除
export const DeletePackageRule = async (params: Recordable) => {
  const usParams = genAction('WMS_ITEM_PKG', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
